//
//  OmnisJSViewController.m
//  OmnisJS
//
//  Created by Bob Mitchell on 31/05/2011.
//  Copyright 2011 TigerLogic UK Ltd. All rights reserved.
//

#import "OmnisJSViewController.h"
#import "OmnisJSAppDelegate.h"

@implementation OmnisJSViewController



/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad 
{
  [super viewDidLoad];

	self.view.autoresizesSubviews = YES;
	self.view.autoresizingMask = UIViewAutoresizingFlexibleHeight|UIViewAutoresizingFlexibleWidth;

	mWebView = [[UIWebView alloc] init];
	mWebView.scalesPageToFit = NO;
	[self.view addSubview:mWebView];
			
	mWebView.frame = self.view.bounds;
	mWebView.delegate = self;
	
	// Load initial URL if required
	[(OmnisJSAppDelegate *) [[UIApplication sharedApplication] delegate] loadURL];
}

- (void) setWebViewFrame:(CGRect)pFrame
{
	self.view.frame = pFrame;
	mWebView.frame = self.view.bounds;
}

// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return YES;
}

// Need this because UIWebView does not generate onorientationchange events
- (void)didRotateFromInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation 
{
	mWebView.frame = self.view.bounds;
	// Tell the JavaScript about the orientation change
	[mWebView stringByEvaluatingJavaScriptFromString:[NSString stringWithFormat:@"didRotateTo('%@')", [self currentOrientationAsString]]];
}

- (NSString*) currentOrientationAsString 
{
	switch([[UIDevice currentDevice] orientation]) {
		case UIDeviceOrientationLandscapeLeft:
    case UIDeviceOrientationLandscapeRight:
    return @"landscape";
	}
  return @"portrait"; // assuming portrait is default
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

- (void) loadURL:(NSString*)url;
{
	[mWebView stopLoading];	// In case a load is in progress
	NSURL *urlObj = [NSURL URLWithString:url];
	NSURLRequest *urlRequest = [NSURLRequest requestWithURL:urlObj];
	[mWebView loadRequest:urlRequest];
}

- (BOOL)webView:(UIWebView *)webView shouldStartLoadWithRequest:(NSURLRequest *)request navigationType:(UIWebViewNavigationType)navigationType
{
  // Intercept custom location change
	NSString *urlString = [[request URL] absoluteString]; 
  if ([urlString caseInsensitiveCompare:@"http://www.omnis.net/__iOSwrapper"] == NSOrderedSame) {
		// For now, this is just called with omnisjs:iOSwrapper - no need to check this yet.
		// Pass the width and height of the available screen area to the JavaScript client
		// Also pass the initial orientation
		NSString *orientation = [self currentOrientationAsString];
		NSString *js = [NSString stringWithFormat:@"setiOSWidthAndHeight(%d,%d,'%@')", (int) mWebView.frame.size.width, (int) mWebView.frame.size.height, orientation];
		[mWebView stringByEvaluatingJavaScriptFromString:js];
		
		return NO;
	}
	return YES;
}

@end
